import numpy as np

import dijkstra

# Part A:
#
graph = {}
graph['start'] = {}
graph['start']['A'] = 2
graph['start']['C'] = 5

graph['A'] = {}
graph['A']['B'] = 7
graph['A']['C'] = 8

graph['B'] = {}
graph['B']['finish'] = 1

graph['C'] = {}
graph['C']['D'] = 4
graph['C']['B'] = 2

graph['D'] = {}
graph['D']['B'] = 6
graph['D']['finish'] = 3

graph['finish'] = {}

# The min costs-to-get-to table:
#
costs = {}
costs['A'] = 2
costs['C'] = 5
costs['B'] = np.inf
costs['D'] = np.inf
costs['finish'] = np.inf

# The parent of each node:
#
parents = {}
parents['start'] = None
parents['A'] ='start'
parents['C'] ='start'
parents['B'] = None
parents['D'] = None
parents['finish'] = None

# We update costs and parents by reference:
#
dijkstra.dijkstra(graph, costs, parents)

print('Part A:')
print(f'Minimum cost to "finish"= {costs["finish"]}')
min_path, cparent = ['finish'], parents['finish']
while cparent is not None:
    min_path.append(cparent)
    cparent = parents[cparent]
min_path = min_path[::-1]
print(f'Path taken to get this minimum: {min_path}')


# Part B:
#
graph = {}

graph['start'] = {}
graph['start']['B'] = 10

graph['A'] = {}
graph['A']['B'] = 1

graph['B'] = {}
graph['B']['C'] = 20

graph['C'] = {}
graph['C']['A'] = 1
graph['C']['finish'] = 30

graph['finish'] = {}

# The min costs-to-get-to table:
#
costs = {}
costs['B'] = 10
costs['A'] = np.inf
costs['C'] = np.inf
costs['finish'] = np.inf

# The parent of each node:
#
parents = {}
parents['start'] = None
parents['B'] ='start'
parents['A'] = None
parents['C'] = None
parents['finish'] = None

# We update costs and parents by reference:
#
dijkstra.dijkstra(graph, costs, parents)

print('Part B:')
print(f'Minimum cost to "finish"= {costs["finish"]}')
min_path, cparent = ['finish'], parents['finish']
while cparent is not None:
    min_path.append(cparent)
    cparent = parents[cparent]
min_path = min_path[::-1]
print(f'Path taken to get this minimum: {min_path}')


